<script setup lang="ts">
    import { useMsal } from '@/plugins/msal/useMsal'
    import { InterventionServiceOfferApi } from '@/interventionServiceOffer/entities/interventionServiceOffer/InterventionServiceOfferApi'
    import {
        interventionServiceOfferInjectionKey,
        myselfGmaoActeurInjectionKey,
    } from '../constants'
    import { serviceOfferIdInjectionKey } from '@/shared/constants'
    import { useServiceOfferSWR } from '@/shared/api/composables/useServiceOfferSWR'
    import { interventionServiceOfferMapper } from '../entities/interventionServiceOffer/InterventionServiceOfferMapper'
    import { provide, ref, watch } from 'vue'
    import { requiredInject } from '@/shared/helpers/types'
    import { GmaoActeurApi } from '../entities/gmaoActeur/GmaoActeurApi'
    import { RequestAborter } from '@/shared/api/entities/RequestAborter'
    import { GmaoActeur } from '@/shared/gmaoActeur/GmaoActeur'

    const msal = useMsal()
    const serviceOfferId = requiredInject(serviceOfferIdInjectionKey)
    //Offre de service
    const interventionServiceOfferApi = new InterventionServiceOfferApi(msal)
    const { securedData: interventionServiceOffer } = useServiceOfferSWR(
        [serviceOfferId.value, '/intervention-service-offers'],
        (serviceOfferId) => interventionServiceOfferApi.get(serviceOfferId),
        interventionServiceOfferMapper.toDto.bind(
            interventionServiceOfferMapper
        ),
        interventionServiceOfferMapper.fromUnsafeDto.bind(
            interventionServiceOfferMapper
        ),
        'SERVICEOFFER_CONSULTER_OFFRE_DE_SERVICE'
    )
    provide(interventionServiceOfferInjectionKey, interventionServiceOffer)

    //Myself
    const gmaoActeurApi = new GmaoActeurApi(msal)
    const gmaoActeurAborter = new RequestAborter()
    const gmaoActeur = ref<GmaoActeur>()
    watch(
        [serviceOfferId, () => msal.accounts],
        (
            [newServiceOfferId, _newAccounts],
            [oldServiceOfferId, _oldAccounts]
        ) => {
            if (newServiceOfferId === oldServiceOfferId) {
                return
            }

            gmaoActeurApi
                .getMyself(serviceOfferId.value, gmaoActeurAborter.getSignal())
                .then((gmaoActeurFetch: GmaoActeur) => {
                    gmaoActeur.value = gmaoActeurFetch
                })
        },
        { immediate: true }
    )

    provide(myselfGmaoActeurInjectionKey, gmaoActeur)
</script>

<template>
    <router-view></router-view>
</template>
